import React, { useMemo } from "react";
import { useRouter } from "./hooks";
export function useRouteLink(href, onClick) {
    const { history } = useRouter();
    return useMemo(() => ({
        onClick(e) {
            try {
                onClick === null || onClick === void 0 ? void 0 : onClick(e);
            }
            catch (error) {
                console.error(error);
            }
            if (!e.defaultPrevented) {
                e.preventDefault();
                history.push(href);
            }
        },
        href: history.urlTo(href),
    }), [href, onClick, history]);
}
export function Link(props) {
    const routeLink = useRouteLink(props.href, props.onClick);
    // eslint-disable-next-line jsx-a11y/anchor-has-content
    return React.createElement("a", Object.assign({}, props, { href: routeLink.href, onClick: routeLink.onClick }));
}
