import React, { useMemo } from "react";
import { useRouter } from "./hooks";
export function Route(props) {
    const router = useRouter();
    const params = useMemo(() => router.matchRoute(props.path, router.path), [props.path, router]);
    if (!params)
        return null;
    const Component = props.component;
    if (Component) {
        let key;
        if (props.addKey === true)
            key = router.path;
        else if (props.addKey)
            key = props.addKey.map((k) => `${k}=${params[k]}`).join("|");
        return React.createElement(Component, { params: params, key: key });
    }
    return typeof props.children === "function" ? props.children(params) : props.children;
}
