import { getPathWithoutBasename } from "./basename";
export const getHashPath = () => window.location.hash.substr(1);
export function createHistory(hashMode, basename, setPath) {
    const { location, history } = window;
    const onChange = hashMode ? () => setPath(getHashPath()) : () => setPath(getPathWithoutBasename(basename));
    const urlTo = hashMode
        ? (path) => `${location.pathname}${location.search}#${path}`
        : (path) => `${basename}${path}`;
    window.addEventListener("popstate", onChange);
    return {
        push(path) {
            const newPath = urlTo(path);
            // Only push if something changed.
            if (newPath !== location.pathname + location.search + location.hash)
                history.pushState({}, "", newPath);
            onChange();
        },
        replace(path) {
            history.replaceState({}, "", urlTo(path));
            onChange();
        },
        stop() {
            window.removeEventListener("popstate", onChange);
        },
        urlTo,
    };
}
